#include "menu.hpp"
using namespace std;

Menu::~Menu()
{
    if (m) { delete m; } // a detruktorban trlnnk kell a mtrixot, ha ltrehoztuk
}

void Menu::Run()
{
    bool bad = false;
    do
    {
        cout << "Mekkora legyen a mtrix mrete? ";
        int s;
        cin >> s;

        if (cin.fail()) // ellenrizzk a bemenetet
        {
            cin.clear();
            bad = true;
        }

        try
        {
            m = new TridiagonalMatrix(s); // megprbljuk ltrehozni a mtrixot
            bad = false;
        }
        catch (TridiagonalMatrix::Exceptions ex) // ha nem sikerlt
        {
            bad = true;
        }
    }
    while (bad); // ismteljk, amg nem sikerlt

    int c = 0;
    do
    {
        Write();
        cin >> c;
        switch (c)
        {
        case 1:
            cin >> *m; // beolvassuk a mtrixot (gyelni kell, hogy ne a mutatt adjuk t)
            break;
        case 2:
            Get();
            break;
        case 3:
            Set();
            break;
        case 4:
            cout << *m;
            break;
        case 5:
            Plus();
            break;
        case 6:
            Minus();
            break;
        }
    }
    while (c != 0);
}
void Menu::Write()
{
    cout << endl << endl;
    cout << " 1. Mtrix feltltse" << endl;
    cout << " 2. Mtrix adott elemnek lekrdezse" << endl;
    cout << " 3. Mtrix adott elemnek fellirsa" << endl;
    cout << " 4. Mtrix kirsa" << endl;
    cout << " 5. Mtrixok sszeadsa" << endl;
    cout << " 6. Mtrixok kivonsa" << endl;
    cout << " 0. Kilps" << endl;
}
void Menu::Get()
{
    int i,j;
    cout << "Adja meg a sor indexet:";
    cin >> i;
    cout << "Adja meg az oszlop indexet:";
    cin >> j;
    cout << "a[" << i << "," << j << "]= ";
    try
    {
        cout << (*m)(i,j);
        // vagy: cout << m->GetValue(i, j);
    }
    catch (TridiagonalMatrix::Exceptions ex)
    {
        switch (ex)
        {
        case TridiagonalMatrix::INDEXOUTOFRANGE:
            cout << "Tlindexles!" << endl;
            break;
        }
    }
}
void Menu::Set()
{
    int i,j, v;
    cout << "Adja meg a sor indexet:";
    cin >> i;
    cout << "Adja meg az oszlop indexet:";
    cin >> j;
    try
    {
        cout << "Adja meg az rtket:";
        cin >> v;

        if (cin.fail())
        {
            cin.clear();
            cout << "Hibs bemenet!" << endl;
        }

        (*m)(i, j) = v;
        // vagy: m->SetValue(i, j, v);
    }
    catch (TridiagonalMatrix::Exceptions ex)
    {
        switch (ex)
        {
        case TridiagonalMatrix::INDEXOUTOFRANGE:
            cout << "Tlindexels!" << endl;
            break;
        case TridiagonalMatrix::NULLREGION:
            cout << "Diagonlison kivl es elem nem irhat!\n";
            break;
        }
    }
}
    void Menu::Plus()
    {
        cout << "Msodik mtrix:" << endl;
        TridiagonalMatrix b(m->Size());
        cin >> b;
        cout << "a + b =" << endl << *m + b << endl;
    }
    void Menu::Minus()
    {
        cout << "Msodik mtrix:" << endl;
        TridiagonalMatrix b (m->Size());
        cin >> b;
        cout << "a - b =" << endl << *m - b << endl;
    }
